{***************************************************************************}
{*                                                                         *}
{*                             ASSEMBLATORE                                *}
{*                                                                         *}
{***************************************************************************}
                              {------------------------------------}
                              {-     modificare nel programma     -}
                              {-        il valore di IP           -}
                              {- utile per indicare la locazione  -}
                              {-   di memoria da cui deve essere  -}
                              {-        scritto il programma      -}
                              {------------------------------------}
program assemblatore;
uses crt;

const
max2=160;  {modificare questo valore in base al num.di c.o. presenti nel file}
           {deve essere un valore >= dei c.o. presenti}
max1=101;  {numero che serve per assegnare le locazioni della tabella hash in
            base alla quale il puntatore hash si pu spostare da una
            posizione che va da 0 a tale valore. oss: tale valore deve essere
            un numero primo}


type
  element2=record
            codoperat:string[8];
            binario:string[8];
           end;
  tabell2=array[1..max2] of element2;
  stringa=string[8];
  stringa16=string[16];
  punt=^elemento;
  elemento=record
           targhetta:string[8];
           indirizzo:integer;
           segue:punt;
          end;
  tabella=array[1..max1] of elemento;


var
 etichetteuguali,inesistentecod,indirizzamentoerrore,inesistentelabel,impossibilepa0,esadecimalerrore:boolean;
 riga:string[33];
 dati,listin:text;
 code,contoperand:integer;
 dicoto16:stringa16;
 lbl,etic,num,IR1,indiriz,str1,str2:string[8];
 operan:string[8];
 strris,IR2:string[16];
 parola:string[60];
 t:tabell2;
 tabe:tabella;
 nacchina:file of integer;

function hash(s1:stringa):integer;
   var
     numero:longint;
   begin
     numero:=ord(s1[1])+ord(s1[2])*10+ord(s1[3])*100+
             ord(s1[4])*1000+ord(s1[5])*10000+
             ord(s1[6])*100000+ord(s1[7])*1000000+
             ord(s1[8])*10000000;
     hash:=numero mod 101;
    end;



procedure hashins;

 var
  lbl:string[8]; {in tale stringa  presente i label che vengono inseriti
                  nella tabella hash grazie alla funzione hash che crea un
                  puntatore in modo opportuno}
  parola:text;   {tale variabile rappresenta nel programma il file graziano.txt}
  IP,i:integer;
  p:punt;
  ricercare:char;
  indicind:string[3];


procedure inserisci(lbl:stringa;operan:stringa);
 var
  pt,p:punt;
  c:char;
  i,valore:integer;
 begin
  if ((lbl<>'        ')and(lbl[1]<>#13)) then begin
      i:=hash(lbl);
      if tabe[i].targhetta=' ' then
                              begin
                               tabe[i].targhetta:=lbl;
                                  if lbl[1]='#' then
                                                 begin
                                                  val(operan,valore,code);
                                                  tabe[i].indirizzo:=valore;
                                                 end
                                                else
                                                  tabe[i].indirizzo:=IP;
                              end
                        else
                          if tabe[i].targhetta=lbl then
                                               etichetteuguali:=true
                                             else
                                               begin
                                                 new(pt);
                                                 pt^.segue:=nil;
                                                 pt^.targhetta:=lbl;
                                                 if lbl[1]='#' then
                                                                 begin
                                                     val(operan,valore,code);
                                                     pt^.indirizzo:=valore;
                                                                 end
                                                               else
                                                     pt^.indirizzo:=IP;
                                                 if tabe[i].segue=nil then
                                                                     tabe[i].segue:=pt
                                                                    else
                                                                      begin
                                                                        p:=tabe[i].segue;
                                                                         while p^.segue<>nil do
                                                                          if p^.targhetta=lbl then
                                                                             begin
                                                                               clrscr;
                                                                               etichetteuguali:=true;
                                                                               p^.segue:=nil
                                                                             end
                                                                             else
                                                                              p:=p^.segue;
                                                                        p^.segue:=pt;
                                                                      end;
                                               end;

                     end
      end;


begin
  clrscr;
  assign(parola,'c:\graziano.txt');
  reset(parola);
  IP:=5*256; {///il valore iniziale di IP decide da quale pagina iniziare///}
         {con il valore 0 si parte dalla pagina 0 }
  for i:=1 to max1 do
                 begin
                    tabe[i].segue:=nil;
                    tabe[i].indirizzo:=0;
                    tabe[i].targhetta:=' ';
                 end;
  while not eof(parola) do
                      begin
                        readln(parola,riga);
                        lbl:=copy(riga,1,8);
                        indicind:=copy(riga,13,3);
                        operan:=copy(riga,18,8);
                        inserisci(lbl,operan);
                        if (indicind='ass')or(indicind='abx')or(indicind='aby')
                           or(indicind='ind') then IP:=IP+3;
                        if (indicind='pa0')or(indicind='(x)')or(indicind='()y')
                           or(indicind='p0x')or(indicind='p0y')or(indicind='imm')
                           or(indicind='rel') then IP:=IP+2;
                        if (indicind='imp')or(indicind='acc') then IP:=IP+1;
                      end;

end;


procedure tabinser;
var
 i:integer;
begin
  assign(dati,'c:\dicotomi.txt');
  reset(dati);
  i:=0;
  while not eof(dati) do
     begin
       readln(dati,dicoto16);
       lbl:=copy(dicoto16,1,8);
       num:=copy(dicoto16,9,8);
       i:=i+1;
       t[i].codoperat:=lbl;
       t[i].binario:=num;
     end;
end;


procedure tabricer;
var
 a,b,c,m,i:integer;
begin
 a:=1;
 b:=max2+1;
 c:=(a+b) div 2;
 for m:=1 to max2 do
              begin
                if lbl<>t[c].codoperat then        {modificare opportunamente max2
                                                    che rappresenta quanti c.o.
                                                    sono presenti               }
                                       begin
                                        if lbl<t[c].codoperat then
                                                                begin
                                                                 a:=a;
                                                                 b:=c;
                                                                end
                                                               else
                                                                begin
                                                                 a:=c;
                                                                 b:=b;
                                                                end;
                                        c:=(a+b) div 2
                                      end
                                     else
                                      begin
                                       if lbl<>t[c].codoperat then
                                                       inesistentecod:=true;
                                       IR1:=t[c].binario;
                                       i:=0;
                                      end;

              end;
 end;

{ricarca dalla tabella hash il valore corrispondente ai label
 e chamati dagli operandi. In tal caso  tale procedura determina
 anche una stringa che contiene il cod. binario corrispondente
 al valore presente in integer nella tabella hash               }

procedure ricerca(stri:stringa16);
 var
  q:punt;
  p:integer;
  risult:array[1..16] of integer;   {sar presente il binario in integer}
                                   {array che serve solo in questa procedura}
  indiriz,i:integer;
 begin
   p:=hash(stri);
   if stri=tabe[p].targhetta then
                            indiriz:=tabe[p].indirizzo
                          else
                            if tabe[p].segue=nil then
                                               begin
                                                 inesistentelabel:=true;
                                               end
                                              else
                                               begin
                                                 q:=tabe[p].segue;                     {************************}
                                                    while q<>nil do                    {*** ricerca tab hash ***}
                                                     if stri=q^.targhetta then         {************************}
                                                                           begin
                                                                              indiriz:=q^.indirizzo;
                                                                              q:=nil;
                                                                           end
                                                                          else
                                                                             if q^.segue<>nil then
                                                                                                q:=q^.segue
                                                                                             else
                                                                                                begin
                                                                                                   q:=nil;

                                                                                                   inesistentelabel:=true;
                                                                                                end;


                                                    end;
 strris:='                ';        {determina il corrispondente cod. binario
                                          in una stringa di caratteri}
 for i:=1 to 16 do
            begin
              risult[17-i]:=indiriz mod 2;
              indiriz:=indiriz div 2;
            end;
 for i:=1 to 16 do
            strris[i]:=chr(risult[i]+48);

 end;

procedure tutto(operan:stringa16);
var
inversa1,inversa2:string[8];
begin
 if operan[1]=' ' then
                 contoperand:=0
                else
                 contoperand:=1;
 if contoperand=1 then
                   begin
                      ricerca(operan);
                      inversa1:=copy(strris,1,8);
                      inversa2:=copy(strris,9,16);         {inverte l'indirizzo nel cod. macchina
                                                            prima il byte meno significativo e poi
                                                            quello pi significativo}
                      IR2:=concat(inversa2,inversa1);
                   end;
end;

procedure secondaparte;  {procedura che collega l'operando al tipo di indirizzamento}
var
frazlbl:string[3];


procedure pagina0;
var
parte1,parte2:string[8];
begin
 tutto(operan);
 parte1:=copy(IR2,9,16);
 parte2:=copy(IR2,1,8);
 if parte1='00000000' then
                       begin
                        IR2:='                ';
                        insert(parte2,IR2,1);
                       end
                      else
                        begin
                         impossibilepa0:=true;
                        end;
end;


procedure  numerohexbin(operan:stringa16); {deve fare la conv. da hex a bin}
var
 v:array[1..2] of string[4];
 i:integer;
begin
 for i:=1 to 2 do
    case operan[i] of
       '0':v[i]:='0000';
       '1':v[i]:='0001';
       '2':v[i]:='0010';
       '3':v[i]:='0011';
       '4':v[i]:='0100';
       '5':v[i]:='0101';
       '6':v[i]:='0110';
       '7':v[i]:='0111';
       '8':v[i]:='1000';
       '9':v[i]:='1001';
       'a':v[i]:='1010';
       'A':v[i]:='1010';
       'b':v[i]:='1011';
       'B':v[i]:='1011';
       'c':v[i]:='1100';
       'C':v[i]:='1100';
       'd':v[i]:='1101';
       'D':v[i]:='1101';
       'e':v[i]:='1110';
       'E':v[i]:='1110';
       'f':v[i]:='1111';
       'F':v[i]:='1111';
    else
      begin
       v[1]:=' err';   {se  nell' immediato o relativo non  presente un valore}
       v[2]:='ore!';   {esadecimale, esce  errore al posto del numero assegnato}
       esadecimalerrore:=true;
      end;
    end;
 IR2:=concat(v[1],v[2],'        ');
end;


begin
frazlbl:=copy(lbl,4,3);
if   (frazlbl='imp')or(frazlbl='acc')or(frazlbl='ass')or(frazlbl='abx')
   or(frazlbl='aby')or(frazlbl='pa0')or(frazlbl='(x)')or(frazlbl='()y')
   or(frazlbl='p0x')or(frazlbl='p0y')or(frazlbl='ind')or(frazlbl='imm')
   or(frazlbl='rel')or(frazlbl='   ')      then
                            begin
                             if frazlbl='   ' then IR2:='                ';
                             if frazlbl='imp' then IR2:='                ';
                             if frazlbl='acc' then IR2:='                ';
                             if frazlbl='ass' then tutto(operan);
                             if frazlbl='abx' then tutto(operan);
                             if frazlbl='aby' then tutto(operan);
                             if frazlbl='pa0' then pagina0;
                             if frazlbl='(x)' then pagina0;
                             if frazlbl='()y' then pagina0;
                             if frazlbl='p0x' then pagina0;
                             if frazlbl='p0y' then pagina0;
                             if frazlbl='ind' then tutto(operan);
                             if frazlbl='imm' then numerohexbin(operan);
                             if frazlbl='rel' then numerohexbin(operan);
                            end
                           else
                            indirizzamentoerrore:=true
end;




procedure prendi;
var
 incpos,cont,i:integer;
 macch:string[24];


procedure macchina;
  var
   i:integer;
   vett:array[1..24]of char;
   vettnum:array[1..24]of integer;
 begin
   for i:=1 to 24 do
       vett[i]:=macch[i];
   for i:=1 to 24 do
       vettnum[i]:=ord(vett[i])-48;
   if macch[1]<>' ' then
       if macch[9]=' 'then
                        for i:=1 to 8 do
                        write(nacchina,vettnum[i])
                      else
                        if macch[17]=' 'then
                                         for i:=1 to 16 do
                                         write(nacchina,vettnum[i])
                                        else
                                         for i:=1 to 24 do
                                         write(nacchina,vettnum[i]);
end;
begin
  incpos:=6;
  assign(listin,'c:\listing.txt');
  rewrite(listin);
  assign(dati,'c:\graziano.txt');
  reset(dati);
  parola:='                                                            '#13''#10'';
  writeln('    CODICE MNEMONICO                           CODICE MACCHINA ');
  writeln(' ');
  writeln('label    c.o.    operandi ');
  for i:=1 to 80 do
                begin
                  gotoxy(i,4);
                  write('');
                  gotoxy(i,23);
                  write('');
                end;
  for i:=1 to 23 do
                begin
                  gotoxy(36,i);
                  write('');
                end;
  gotoxy(1,5);
  i:=0;
  while not eof(dati) do
     begin
       readln(dati,riga);   {variabile riga prende da "dati" ( nome  che
                             rappresenta il file graziano) un intera riga}
       if wherey=23 then    {---metodo utile a selezionare le pagine nel monitoraggio---}
                       begin
                         gotoxy(1,24);
                         write('premi invio per continuare');
                         readln;
                         clrscr;
                         writeln('    CODICE MNEMONICO                           CODICE MACCHINA');
                         writeln(' ');
                         writeln('label    c.o.    operandi ');
                         for i:=1 to 80 do
                                        begin
                                          gotoxy(i,4);
                                          write('');
                                          gotoxy(i,23);
                                          write('');
                                        end;
                         for i:=1 to 23 do
                                        begin
                                          gotoxy(36,i);
                                          write('');
                                        end;
                         gotoxy(1,5);
                         incpos:=6;
                       end;
                                  {scanziona la riga in tre stringhe che
                                   rappresentano le tre parti del programma prova}
       etic:=copy(riga,1,8);
       lbl:=copy(riga,10,8);
       operan:=copy(riga,18,8);
       write(riga);
       secondaparte;  {costruisce la secondaperte del cod. macchina che
                       dipende dall'operando e dal tipo di indirizzamento}
       {-+-+-+-+-+--+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-}
                            tabricer;  {chiamata alla ricerca nella tabella
                                         del c.o. confrontata con lbl utile per poi
                                           prendere il valore numerico corrispondente}
                            gotoxy(38,incpos-1);
                            {permette di mettere nella parola tutta una riga di listing}
                            parola:=concat(riga,'   ',IR1,IR2);
                            macch:=copy(parola,37,24);       {serve per ottenere i dati per il file.dat}

                            macchina;    {procedura che crea una riga del file.dat}
                            writeln(listin,parola);
                            write(IR1,IR2);
                            gotoxy(1,incpos);
                            incpos:=incpos+1;   {serve per indicare la posizione
                                                 della stampa del codice macchina}

    end;
     close(listin);
end;

begin             {****  programma principale  ****}
 clrscr;
 etichetteuguali:=false;
 inesistentecod:=false;
 inesistentelabel:=false;
 impossibilepa0:=false;
 esadecimalerrore:=false;
 indirizzamentoerrore:=false;

 assign(nacchina,'c:\macchin.dat');
 rewrite(nacchina);

 hashins;         {creazione della tabella dei simboli}
 tabinser;        {inserimento dei dati nella tabella dei c.o.}
 prendi;          {creazione dei monitoraggio e del file listing}

 close(nacchina);

 writeln(' ');
 if etichetteuguali then
     writeln('errore: nel listato sono presenti almeno due etichette uguali');
 if inesistentecod then
    writeln('errore: nel listato  presente almeno un c.o. inesistente');
 if inesistentelabel then
    writeln('errore: nel listato non  conosciuto un operando');
 if impossibilepa0 then
    writeln('errore: nel listato un c.o. non mira a pag0 con un c.o. di pag0');
 if esadecimalerrore then
                    begin
                     writeln('errore: nel listato ci sono c.o. imm. o rel. con operandi non hex');
                     writeln('        errori scritti sulle righe errate');
                    end;
 if indirizzamentoerrore then
                          begin
                           writeln('errore: nel listato non  conosciuto nel c.o.,l indirizzamento');
                           writeln('        almeno in un c.o. non sono conosciute le ultime tre lettere');
                          end;
readln;
end.
